#include <stdio.h>
#include <stdint.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <termios.h>
#include <unistd.h>

#define SERIAL_PORT "/dev/ttymxc2"

// arm-linux-gnueabihf-gcc serial.c -o serial

int main(int argc, char *argv[])
{
	uint8_t s_buf[2];
	int r_bug[2];
    int fd;
    struct termios tio;
    int baudRate = B38400;
    int ret;
	int i;
	int len;
	unsigned short int recvIdx;
    unsigned short int msgIdx = 1;

    fd = open(SERIAL_PORT, O_RDWR);
    if (fd < 0) {
        printf("open error\n");
        return -1;
    }

    tio.c_cflag += CREAD;
    tio.c_cflag += CLOCAL;
    tio.c_cflag += CS8;
    tio.c_cflag += 0;
    tio.c_cflag += 0;

    cfsetispeed( &tio, baudRate );
    cfsetospeed( &tio, baudRate );

    cfmakeraw(&tio);

    tcsetattr( fd, TCSANOW, &tio );

    ioctl(fd, TCSETS, &tio);

    // 送受信処理ループ
    while(1) {
		s_buf[0] = (msgIdx >> 0) & 0xFF;
		s_buf[1] = (msgIdx >> 8) & 0xFF;

		write(fd, s_buf, sizeof(s_buf));
		
		len = read(fd, r_bug, 2);
		msgIdx++;

		if (msgIdx >= 65535){
			msgIdx = 1;
		}
		usleep(10000);
    }

    close(fd);
    return 0;
}

