#!/usr/bin/env python
# -*- coding:utf-8 -*-

import serial
import sys
import datetime


# シリアルポートを開く
try:
    ser = serial.Serial('COM9', 38400, timeout=60) # PCの環境に合わせてCOMポートは変更する
    
except Exception as e:
    print('Failed open serial port: {}'.format(e))
    sys.exit(0)


# ループバック動作
try:
    with open("./recv.log", mode='w') as f:
        while ser.is_open:
            recvData = ser.read(2)
            now = datetime.datetime.now()
            data = int.from_bytes(recvData, 'little')
            print('{}: {}'.format(now, data))
            f.write('{}: {}\n'.format(now, data))
            ser.write(recvData)
        
except Exception as e:
    print('serial close: {}'.format(e))

ser.close()
sys.exit(0)
